import logging
import ctranslate2
import transformers



def get_model(model_path, device_type, device_num,src_lang):
    translator = ctranslate2.Translator(model_path, device_type, device_index=device_num)
    # tokenizer = transformers.AutoTokenizer.from_pretrained(model_path,src_lang="en")
    tokenizer = transformers.AutoTokenizer.from_pretrained(model_path, src_lang=src_lang)

    return translator, tokenizer

def model_infer(model_path, device_num, Sentence, batch_size=64,src_lang="eng_Latn"):
    translator, tokenizer = get_model(model_path, "cuda", device_num,src_lang)
    data = []
    data.append(Sentence)

    sentences = [tokenizer.convert_ids_to_tokens(tokenizer.encode(seq)) for seq in data]
    # target_prefix = [tokenizer.lang_code_to_token["zh"]]
    target_prefix=["zho_Hans"]
    results = translator.translate_batch(sentences, target_prefix=[target_prefix] * len(data),max_batch_size=batch_size,repetition_penalty=2,disable_unk=True,)
    targets = [result.hypotheses[0][1:] for result in results]
    infer_results = [tokenizer.decode(tokenizer.convert_tokens_to_ids(target)) for target in targets]

    return infer_results

#对美国来说，北约转向东亚具有重要的战略意义。美国政府正寻求将其松散的联盟网络整合成一个更牢固的、能遏制中国崛起的联盟，从而维持其全球霸权地位。

if __name__ == "__main__":

    src_lang = "eng_Latn"
    model_path="/disk1/work/liaozm/Exist_Trans_Model/NLLB200/C2_NLLB200/C2_2024_26latn_model"
    model_path="/disk1/work/liaozm/Exist_Trans_Model/NLLB200/C2_1.3B"
    device_num = 6
    Sentence="Polska trzeci raz z rzędu znalazła się na ostatnim miejscu wśród krajów Unii Europejskiej Homofobiczne prawo w Polsce sytuuje nas tuż obok Rosji"
    Sentence="Na porządku dziennym jest zarówno brak deklarowanej substancji w produkcie, jak i obecność substancji niedozwolonej lub innych zanieczyszczeń z bakteriami kałowymi włącznie Fikcją jest też często umieszczone na etykiecie pochodzenie produktu."
    Sentence="Recalling a large number of products"
    Sentence="Es gibt viele Äpfel an diesem Baum"
    Sentence="Britain's ambassador is to be airlifted from Afghanistan by Monday evening amid fears that the Taliban could imminently take Kabul and seize the airport that would provide the only means of escape."
    Sentence="an apple"
    # Sentence = "Many metallic elements such as zinc, copper, magnesium"
    print(model_infer(model_path, device_num, Sentence, batch_size=1280,src_lang="eng_Latn"))





